<?php	 	 
if( !defined( '_VALID_MOS' ) && !defined( '_JEXEC' ) ) die( 'Direct Access to '.basename(__FILE__).' is not allowed.' );
/**
*
* @version $Id: envialia.cfg.php 2011-09-20 mia_soluciones_web $
* @package VirtueMart
* @subpackage shipping
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
* VirtueMart is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See /administrator/components/com_virtuemart/COPYRIGHT.php for copyright notices and details.
*
* http://virtuemart.net
*/
class envialia {

	function list_rates( &$d ) {
		global $vendor_country_2_code, $vendor_currency, $vmLogger;
		global $VM_LANG, $CURRENCY_DISPLAY, $mosConfig_absolute_path;
		global $total,$tax_total;
		$db_cliente = new ps_DB;
		$db_vendedor = new ps_DB;

		$carrito = $_SESSION['cart'];

		/** Read current Configuration ***/
		require_once(CLASSPATH ."shipping/".__CLASS__.".cfg.php");

		$q  = "SELECT * FROM #__{vm}_user_info, #__{vm}_country WHERE user_info_id='" . $d["ship_to_info_id"]."' AND ( country=country_2_code OR country=country_3_code)";
		$db_cliente->query($q);

		$q  = "SELECT * FROM #__{vm}_vendor WHERE vendor_id='".$_SESSION['ps_vendor_id']."'";
		$db_vendedor->query($q);
		$db_vendedor->next_record();

		$peso_pedido = $d['weight'];

		if($peso_pedido > 0) {

			if( $peso_pedido < 1 ) {
				$peso_pedido = 1;
			}
			
			$pais_cliente = $db_cliente->f('country_2_code');
            $cp_cliente = $db_cliente->f('zip');
            
            $envialia_impuesto = 0;
			//Verificamos si hay que agregar el impuesto
			if($this->agregar_impuesto($pais_cliente)){
				$envialia_impuesto = floatval(ENVIALIA_IMPUESTO);
			}


			// Verificamos si el cliente pertenece a España , Portugal o Andorra
			if($pais_cliente == 'ES' || $pais_cliente == 'PT' || $pais_cliente == 'AD'){

                            // Primero comprobamos si hay servicio gratuito
			    if(ENVIALIA_HABILITAR_ENVIO_GRATUITO){
			        // Comprobamos que superamos el importe minimo para envio gratuito
			        if(ENVIALIA_IMPORTE_MINIMO_ENVIO_GRATUITO < $total){
                                    if(ENVIALIA_SERVICIO_ENVIO_GRATUITO == "E24"){
                                        $tipo_servicio = "E24";
                                        $servicio = "al día siguiente";
                                        $importe = "GRATUITO";
                                        
                                    }
                                    if(ENVIALIA_SERVICIO_ENVIO_GRATUITO == "E72"){
                                        $tipo_servicio = "E72";
                                        $servicio = "máximo en tres días";
                                        $importe = "GRATUITO";
                                    }
                                    $shipping_rate_id = $this->crear_string_shipping_rate_id($tipo_servicio, 0, TRUE, $peso_pedido);
                                    $html = "\n<input type=\"radio\" name=\"shipping_rate_id\" checked=\"checked\" value=\"$shipping_rate_id\" id=\"$shipping_rate_id\" />\n";
                                    $_SESSION[$shipping_rate_id] = 1;
									$html .= "<img src=\"http://www.envialia-urgente.com/images/envialia_ecomm_gratuito.png\">";
                                    $html .= "<label for=\"$shipping_rate_id\">";
                                    $html .= " servicio de entrega ".$servicio." <strong>(".$importe.")</strong>";
                                    $html .= "</label>";
                                    $html .= "<br />";
                                    echo $html;
                                    return true;
                                }
			    }

                            // No hay servicio gratuito
                            $html='';
                            $impuesto = 0;
                            $coste_envio = 0;
                            $importe = 0;
                            $coste_fijo_envio = 0;
                            $coste_manipulacion = 0;
                            $coste_margen = 0;
                            $tarifas = $this->tarifas();

                            if(ENVIALIA_COSTE_FIJO_ENVIO){$coste_fijo_envio = floatval(ENVIALIA_COSTE_FIJO_ENVIO);}
                            if(ENVIALIA_MANIPULACION == 'F'){$coste_manipulacion = floatval(ENVIALIA_COSTE_MANIPULACION);}
                            if(ENVIALIA_MANIPULACION == 'V'){$coste_manipulacion = floatval($total*(ENVIALIA_COSTE_MANIPULACION/100));}
                            if(ENVIALIA_MARGEN_COSTE_ENVIO){$coste_margen = floatval(ENVIALIA_MARGEN_COSTE_ENVIO);}
                            
                            if(ENVIALIA_ECOMM_24H){
                                $tipo_servicio = "E24";
                                $servicio = "al día siguiente";
                                $importe = 0;
                                if(ENVIALIA_COSTE_FIJO_ENVIO){
                                    $coste_envio = $coste_fijo_envio+($coste_fijo_envio*$envialia_impuesto);
                                    $importe = floatval($coste_envio+$coste_manipulacion);
                                }
                                else{
                                    //Si no hay coste_fijo buscamos en el csv el precio
                                    //necesitamos el tipo_servicio, cp_cliente, pais y peso
                                    $coste_envio = $this->dame_tarifa($tarifas, $tipo_servicio, $pais_cliente, $cp_cliente, $peso_pedido);
                                    //Verificamos coste de envio
                                    if(!$coste_envio){
                                        $vmLogger->err( 'ENVIALIA ERROR: el país o el código postal son incorrectos, por favor revíselos a través de su cuenta de usuario registrado.');
                                        return;
                                    }
                                    //Despues sumarle el MARGEN SOBRE COSTE DE ENVÍO
                                    if(ENVIALIA_MARGEN_COSTE_ENVIO){
                                        $coste_envio=$coste_envio+(floatval(ENVIALIA_MARGEN_COSTE_ENVIO));
                                    }
                                    $coste_envio = $coste_envio +($coste_envio*$envialia_impuesto);
                                    $importe = floatval($coste_envio+$coste_manipulacion);
                                }
                                //formateamos el importe
                                $importe = number_format($importe,2,".","");

                                // Preparamos el HTML
                                $shipping_rate_id = $this->crear_string_shipping_rate_id($tipo_servicio, $importe, TRUE, $peso_pedido);
                                $html .= "\n<input type=\"radio\" name=\"shipping_rate_id\" checked=\"checked\" value=\"$shipping_rate_id\" id=\"$shipping_rate_id\" />\n";
                                $_SESSION[$shipping_rate_id] = 1;
								$html .= "<img src=\"http://www.envialia-urgente.com/images/envialia_ecomm_24.png\">";
                                $html .= "<label for=\"$shipping_rate_id\">";
								$html .= " servicio de entrega ".$servicio." <strong>(".$CURRENCY_DISPLAY->getFullValue($importe).")</strong>";
                                $html .= "</label>";
                                $html .= "<br />";
			    }
			    if(ENVIALIA_ECOMM_72H){
                                $tipo_servicio = "E72";
                                $servicio = "máximo en tres días";
                                $importe = 0;
                                if(ENVIALIA_COSTE_FIJO_ENVIO){
                                    $coste_envio = $coste_fijo_envio+($coste_fijo_envio*$envialia_impuesto);
                                    $importe = floatval($coste_envio+$coste_manipulacion);
                                }
                                else{
                                    //Si no hay coste_fijo buscamos en el csv el precio
                                    //necesitamos el tipo_servicio, cp_cliente, pais y peso
                                    $coste_envio = $this->dame_tarifa($tarifas, $tipo_servicio, $pais_cliente, $cp_cliente, $peso_pedido);
                                    //Verificamos coste de envio
                                    if(!$coste_envio){
                                        $vmLogger->err( 'ENVIALIA ERROR: el país o el código postal son incorrectos, por favor revíselos a través de su cuenta de usuario registrado.');
                                        return;
                                    }
                                    //Despues sumarle el MARGEN SOBRE COSTE DE ENVÍO
                                    if(ENVIALIA_MARGEN_COSTE_ENVIO){
                                        $coste_envio=$coste_envio+(floatval(ENVIALIA_MARGEN_COSTE_ENVIO));
                                    }
                                    $coste_envio = $coste_envio +($coste_envio*$envialia_impuesto);
                                    $importe = floatval($coste_envio+$coste_manipulacion);
                                }
                                //formateamos el importe
                                $importe = number_format($importe,2,".","");

                                // Preparamos el HTML
                                $shipping_rate_id = $this->crear_string_shipping_rate_id($tipo_servicio, $importe, TRUE, $peso_pedido);
                                $html .= "\n<input type=\"radio\" name=\"shipping_rate_id\" checked=\"checked\" value=\"$shipping_rate_id\" id=\"$shipping_rate_id\" />\n";
                                $_SESSION[$shipping_rate_id] = 1;
								$html .= "<img src=\"http://www.envialia-urgente.com/images/envialia_ecomm_72.png\">";
                                $html .= "<label for=\"$shipping_rate_id\">";
                                $html .= " servicio de entrega ".$servicio." <strong>(".$CURRENCY_DISPLAY->getFullValue($importe).")</strong>";
                                $html .= "</label>";
                                $html .= "<br />";
			    }			
			}
                        //Verificamos si el cliente es de EUROPA
			else if($this->es_europeo($pais_cliente)){
                            // Primero comprobamos si hay servicio gratuito para EUROPA
                            // En Europa pueden usar tambien el INTERNACIONAL
			    if(ENVIALIA_HABILITAR_ENVIO_GRATUITO_INTERNACIONAL){
			        // Comprobamos que superamos el importe minimo para envio gratuito
			        if(ENVIALIA_IMPORTE_MINIMO_ENVIO_GRATUITO_INTERNACIONAL < $total){
                                    if(ENVIALIA_SERVICIO_ENVIO_GRATUITO_INTERNACIONAL == "EEU"){
                                        $tipo_servicio = "EEU";
                                        $servicio = "EUROPE EXPRESS";
                                        $importe = "GRATUITO";

                                    }
                                    if(ENVIALIA_SERVICIO_ENVIO_GRATUITO_INTERNACIONAL == "EWW"){
                                        $tipo_servicio = "EWW";
                                        $servicio = "WORLDWIDE";
                                        $importe = "GRATUITO";
                                    }
                                    $shipping_rate_id = $this->crear_string_shipping_rate_id($tipo_servicio, 0, TRUE, $peso_pedido);
                                    $html = "\n<input type=\"radio\" name=\"shipping_rate_id\" checked=\"checked\" value=\"$shipping_rate_id\" id=\"$shipping_rate_id\" />\n";
                                    $_SESSION[$shipping_rate_id] = 1;
								$html .= "<img src=\"http://www.envialia-urgente.com/images/envialia_ecomm_internacional.png\">";
                                    $html .= "<label for=\"$shipping_rate_id\">";
                                    $html .= " servicio de entrega ".$servicio." <strong>(".$importe.")</strong>";
                                    $html .= "</label>";
                                    $html .= "<br />";
                                    echo $html;
                                    return true;
                                }
			    }
                            // No hay servicio gratuito Europeo o Internacional
                            $html='';
                            $impuesto = 0;
                            $coste_envio = 0;
                            $importe = 0;
                            $coste_fijo_envio = 0;
                            $coste_manipulacion = 0;
                            $coste_margen = 0;
                            $tarifas = $this->tarifas();

                            //if(ENVIALIA_CLASE_IMPUESTO){$impuesto =  $this->get_tax_rate();}
                            if(ENVIALIA_COSTE_FIJO_ENVIO){$coste_fijo_envio = floatval(ENVIALIA_COSTE_FIJO_ENVIO);}
                            if(ENVIALIA_MANIPULACION == 'F'){$coste_manipulacion = floatval(ENVIALIA_COSTE_MANIPULACION);}
                            if(ENVIALIA_MANIPULACION == 'V'){$coste_manipulacion = floatval($total*(ENVIALIA_COSTE_MANIPULACION/100));}
                            if(ENVIALIA_MARGEN_COSTE_ENVIO){$coste_margen = floatval(ENVIALIA_MARGEN_COSTE_ENVIO);}

                            if(ENVIALIA_ECOMM_EUROPE_EXPRESS){
                                $tipo_servicio = "EEU";
                                $servicio = "EUROPE EXPRESS";
                                $importe = 0;
                                if(ENVIALIA_COSTE_FIJO_ENVIO){
                                    $coste_envio = $coste_fijo_envio+($coste_fijo_envio*$envialia_impuesto);
                                    $importe = floatval($coste_envio+$coste_manipulacion);
                                }
                                else{
                                    //Si no hay coste_fijo buscamos en el csv el precio
                                    //necesitamos el tipo_servicio, cp_cliente, pais y peso
                                    $coste_envio = $this->dame_tarifa($tarifas, $tipo_servicio, $pais_cliente, $cp_cliente, $peso_pedido);
                                    //Verificamos coste de envio
                                    if(!$coste_envio){
                                        $vmLogger->err( 'ENVIALIA ERROR: el país o el código postal son incorrectos, por favor revíselos a través de su cuenta de usuario registrado.');
                                        return;
                                    }
                                    //Despues sumarle el MARGEN SOBRE COSTE DE ENVÍO
                                    if(ENVIALIA_MARGEN_COSTE_ENVIO){
                                        $coste_envio=$coste_envio+(floatval(ENVIALIA_MARGEN_COSTE_ENVIO));
                                    }
                                    $coste_envio = $coste_envio +($coste_envio*$envialia_impuesto);
                                    $importe = floatval($coste_envio+$coste_manipulacion);
                                }
                                //formateamos el importe
                                $importe = number_format($importe,2,".","");

                                // Preparamos el HTML
                                $shipping_rate_id = $this->crear_string_shipping_rate_id($tipo_servicio, $importe, TRUE, $peso_pedido);
                                $html .= "\n<input type=\"radio\" name=\"shipping_rate_id\" checked=\"checked\" value=\"$shipping_rate_id\" id=\"$shipping_rate_id\" />\n";
                                $_SESSION[$shipping_rate_id] = 1;
								$html .= "<img src=\"http://www.envialia-urgente.com/images/envialia_ecomm_internacional.png\">";
                                $html .= "<label for=\"$shipping_rate_id\">";
                                $html .= " servicio de entrega terrestre ".$servicio." <strong>(".$CURRENCY_DISPLAY->getFullValue($importe).")</strong>";
                                $html .= "</label>";
                                $html .= "<br />";

			    }
			    if(ENVIALIA_ECOMM_WORLDWIDE){
                                $tipo_servicio = "EWW";
                                $servicio = "WORLDWIDE";
                                $importe = 0;
                                if(ENVIALIA_COSTE_FIJO_ENVIO){
                                    $importe = floatval($coste_fijo_envio+$coste_manipulacion);
                                }
                                else{
                                    //Si no hay coste_fijo buscamos en el csv el precio
                                    //necesitamos el tipo_servicio, cp_cliente, pais y peso
                                    $coste_envio = $this->dame_tarifa($tarifas, $tipo_servicio, $pais_cliente, $cp_cliente, $peso_pedido);
                                    //Verificamos coste de envio
                                    if(!$coste_envio){
                                        $vmLogger->err( 'ENVIALIA ERROR: el país o el código postal son incorrectos, por favor revíselos a través de su cuenta de usuario registrado.');
                                        return;
                                    }
                                    //Despues sumarle el MARGEN SOBRE COSTE DE ENVÍO
                                    if(ENVIALIA_MARGEN_COSTE_ENVIO){
                                        $coste_envio=$coste_envio+(floatval(ENVIALIA_MARGEN_COSTE_ENVIO));
                                    }
                                    $importe = floatval($coste_envio+$coste_manipulacion);
                                }
                                //formateamos el importe
                                $importe = number_format($importe,2,".","");

                                // Preparamos el HTML
                                $shipping_rate_id = $this->crear_string_shipping_rate_id($tipo_servicio, $importe, TRUE, $peso_pedido);
                                $html .= "\n<input type=\"radio\" name=\"shipping_rate_id\" checked=\"checked\" value=\"$shipping_rate_id\" id=\"$shipping_rate_id\" />\n";
                                $_SESSION[$shipping_rate_id] = 1;
								$html .= "<img src=\"http://www.envialia-urgente.com/images/envialia_ecomm_internacional.png\">";
                                $html .= "<label for=\"$shipping_rate_id\">";
                                $html .= " servicio de entrega aéreo ".$servicio." <strong>(".$CURRENCY_DISPLAY->getFullValue($importe).")</strong>";
                                $html .= "</label>";
                                $html .= "<br />";
			    }
			}
                        //Es INTERNACIONAL
                        else {
                            // Primero comprobamos si hay servicio gratuito INTERNACIONAL
			    if(ENVIALIA_HABILITAR_ENVIO_GRATUITO_INTERNACIONAL){
			        // Comprobamos que superamos el importe minimo para envio gratuito
			        if(ENVIALIA_IMPORTE_MINIMO_ENVIO_GRATUITO_INTERNACIONAL < $total){
                                    if(ENVIALIA_SERVICIO_ENVIO_GRATUITO_INTERNACIONAL == "EWW"){
                                        $tipo_servicio = "EWW";
                                        $servicio = "WORLDWIDE";
                                        $importe = "GRATUITO";

                                        $shipping_rate_id = $this->crear_string_shipping_rate_id($tipo_servicio, 0, TRUE, $peso_pedido);
                                        $html = "\n<input type=\"radio\" name=\"shipping_rate_id\" checked=\"checked\" value=\"$shipping_rate_id\" id=\"$shipping_rate_id\" />\n";
                                        $_SESSION[$shipping_rate_id] = 1;
								$html .= "<img src=\"http://www.envialia-urgente.com/images/envialia_ecomm_internacional.png\">";
                                        $html .= "<label for=\"$shipping_rate_id\">";
                                        $html .= " servicio de entrega ".$servicio." <strong>(".$importe.")</strong>";
                                        $html .= "</label>";
                                        $html .= "<br />";
                                        echo $html;
                                        return true;
                                    }
                                }
			    }
                            // No hay servicio gratuito Internacional
                            $html='';
                            $impuesto = 0;
                            $coste_envio = 0;
                            $importe = 0;
                            $coste_fijo_envio = 0;
                            $coste_manipulacion = 0;
                            $coste_margen = 0;
                            $tarifas = $this->tarifas();

                            if(ENVIALIA_COSTE_FIJO_ENVIO){$coste_fijo_envio = floatval(ENVIALIA_COSTE_FIJO_ENVIO);}
                            if(ENVIALIA_MANIPULACION == 'F'){$coste_manipulacion = floatval(ENVIALIA_COSTE_MANIPULACION);}
                            if(ENVIALIA_MANIPULACION == 'V'){$coste_manipulacion = floatval($total*(ENVIALIA_COSTE_MANIPULACION/100));}
                            if(ENVIALIA_MARGEN_COSTE_ENVIO){$coste_margen = floatval(ENVIALIA_MARGEN_COSTE_ENVIO);}

                            if(ENVIALIA_ECOMM_WORLDWIDE){
                                $tipo_servicio = "EWW";
                                $servicio = "WORLDWIDE";
                                $importe = 0;
                                if(ENVIALIA_COSTE_FIJO_ENVIO){
                                    $importe = floatval($coste_fijo_envio+$coste_manipulacion);
                                }
                                else{
                                    //Si no hay coste_fijo buscamos en el csv el precio
                                    //necesitamos el tipo_servicio, cp_cliente, pais y peso
                                    $coste_envio = $this->dame_tarifa($tarifas, $tipo_servicio, $pais_cliente, $cp_cliente, $peso_pedido);
                                    //Verificamos coste de envio
                                    if(!$coste_envio){
                                        $vmLogger->err( 'ENVIALIA ERROR: el país o el código postal son incorrectos, por favor revíselos a través de su cuenta de usuario registrado.');
                                        return;
                                    }
                                    //Despues sumarle el MARGEN SOBRE COSTE DE ENVÍO
                                    if(ENVIALIA_MARGEN_COSTE_ENVIO){
                                        $coste_envio=$coste_envio+(floatval(ENVIALIA_MARGEN_COSTE_ENVIO));
                                    }
                                    $importe = floatval($coste_envio+$coste_manipulacion);
                                }
                                //formateamos el importe
                                $importe = number_format($importe,2,".","");
                                // Preparamos el HTML
                                $shipping_rate_id = $this->crear_string_shipping_rate_id($tipo_servicio, $importe, TRUE, $peso_pedido);
                                $html .= "\n<input type=\"radio\" name=\"shipping_rate_id\" checked=\"checked\" value=\"$shipping_rate_id\" id=\"$shipping_rate_id\" />\n";
                                $_SESSION[$shipping_rate_id] = 1;
								$html .= "<img src=\"http://www.envialia-urgente.com/images/envialia_ecomm_internacional.png\">";
                                $html .= "<label for=\"$shipping_rate_id\">";
                                $html .= " servicio de entrega aéreo ".$servicio." <strong>(".$CURRENCY_DISPLAY->getFullValue($importe).")</strong>";
                                $html .= "</label>";
                                $html .= "<br />";
			    }
                        }
                        echo $html;
		}
		return true;
	}

	function get_rate( &$d ) {

		$shipping_rate_id = $d["shipping_rate_id"];
		$is_arr = explode("|", urldecode(urldecode($shipping_rate_id)) );
		$order_shipping = $is_arr[3];

		return $order_shipping;

	}

	function get_tax_rate() {

		/** Read current Configuration ***/
		require_once(CLASSPATH ."shipping/".__CLASS__.".cfg.php");

		if( intval(ENVIALIA_CLASE_IMPUESTO)== 0 ) {
			return( 0 );
		}
		else {
			require_once( CLASSPATH. "ps_tax.php" );
			$tax_rate = ps_tax::get_taxrate_by_id( intval(ENVIALIA_CLASE_IMPUESTO) );
			return $tax_rate;
		}
	}

    /**
    * Validate this Shipping method by checking if the SESSION contains the key
    * @returns boolean False when the Shipping method is not in the SESSION
    */
	function validate( $d ) {

		$shipping_rate_id = $d["shipping_rate_id"];

		if( array_key_exists( $shipping_rate_id, $_SESSION )) {
			return true;
		}
		else {
			return false;
		}
	}

	/**
    * Show all configuration parameters for this Shipping method
    * @returns boolean False when the Shipping method has no configration
    */
	function show_configuration() {

		global $VM_LANG;
		/** Read current Configuration ***/
		require_once(CLASSPATH ."shipping/".__CLASS__.".cfg.php");
    ?>
            <table class="adminform">
        <tr class="row0">
        <td>
            <strong>ID Centro de servicio ENVIALIA</strong>
      </td>
		<td>
            <input type="text" name="ENVIALIA_CODIGO_AGENCIA" class="inputbox" size="6" maxlength="6" value="<?php echo ENVIALIA_CODIGO_AGENCIA ?>" />
		</td>
		<td>
          <?php	echo mm_ToolTip("Código de centro de servicio ENVIALIA") ?>
        </td>
</tr>
    <tr class="row1">
        <td>
            <strong>ID Cuenta ENVIALIA</strong>
		</td>
		<td>
            <input type="text" name="ENVIALIA_CODIGO_CLIENTE" class="inputbox" size="5" maxlength="5" value="<?php	echo ENVIALIA_CODIGO_CLIENTE ?>" />
		</td>
		<td>
            <?php echo mm_ToolTip("Código de cuenta ENVIALIA") ?>
        </td>
    </tr>
    <tr class="row0">
        <td>
            <strong>Password ENVIALIA</strong>
		</td>
		<td>
            <input type="text" name="ENVIALIA_PASSWORD_CLIENTE" class="inputbox" size="15" maxlength="15" value="<?php echo ENVIALIA_PASSWORD_CLIENTE ?>" />
		</td>
		<td>
            <?php echo mm_ToolTip("Password de cuenta ENVIALIA") ?>
        </td>
    </tr>
    <tr class="row1">
        <td>
            <strong>Servidor ENVIALIA</strong>
        </td>
		<td>
            <input type="text" name="ENVIALIA_URL" class="inputbox" maxlength="50" value="<?php echo ENVIALIA_URL ?>" />
		</td>
		<td>
          <?php	echo mm_ToolTip("Servidor API ENVIALIA, solicítalo en tu centro de servicio ENVIALIA . 902400909") ?>
        </td>
    </tr>

    <tr>
        <td class="row0" colspan="3">
            <hr>
        </td>
    </tr>

    <tr class="row0">
        <td><strong>HABILITAR ENVIO GRATUITO PARA ESPAÑA-PORTUGAL-ANDORRA</strong></td>
		<td>
		  <input class="inputbox" <?php if(ENVIALIA_HABILITAR_ENVIO_GRATUITO=="0") echo "checked=\"checked\"" ?> type="radio" name="ENVIALIA_HABILITAR_ENVIO_GRATUITO" value="0" />No
		  <input class="inputbox" <?php if(ENVIALIA_HABILITAR_ENVIO_GRATUITO=="1") echo "checked=\"checked\"" ?> type="radio" name="ENVIALIA_HABILITAR_ENVIO_GRATUITO" value="1" />Si
		</td>
		<td><?php echo mm_ToolTip("Habilita el envío gratuito a los siguientes paises: ES-PT-AD.") ?></td>
    </tr>
	<tr class="row0">
	  <td><strong>SERVICIO PARA ENVIO GRATUITO PARA ESPAÑA-PORTUGAL-ANDORRA</strong></td>
	  <td>
	    <select class="inputbox" name="ENVIALIA_SERVICIO_ENVIO_GRATUITO">
              <option <?php if(!ENVIALIA_SERVICIO_ENVIO_GRATUITO) echo "selected=\"selected\"" ?> value="0"> - elija un servicio - </option>
	      <option <?php if(ENVIALIA_SERVICIO_ENVIO_GRATUITO=="E24") echo "selected=\"selected\"" ?> value="E24">E-COMM 24H</option>
	      <option <?php if(ENVIALIA_SERVICIO_ENVIO_GRATUITO=="E72") echo "selected=\"selected\"" ?> value="E72">E-COMM 72H</option>
        </select>
	  </td>
	  <td><?php echo mm_ToolTip("Servicio para envío gratuito a ES-PT-AD") ?></td>
	</tr>
	<tr class="row0">
	  <td><strong>Importe mínimo envío gratuito ES-PT-AD</strong></td>
	  <td>
            <input type="text" name="ENVIALIA_IMPORTE_MINIMO_ENVIO_GRATUITO" class="inputbox" value="<?php	echo ENVIALIA_IMPORTE_MINIMO_ENVIO_GRATUITO ?>" />
	  </td>
	  <td><?php echo mm_ToolTip("Importe mínimo de pedido para envío gratuito a ES-PT-AD") ?></td>
	</tr>

        <tr>
            <td class="row0" colspan="3">
                <hr>
            </td>
        </tr>

     <tr class="row0">
        <td><strong>Habilitar envío gratuito INTERNACIONAL</strong></td>
		<td>
		  <input class="inputbox" <?php if(ENVIALIA_HABILITAR_ENVIO_GRATUITO_INTERNACIONAL=="0") echo "checked=\"checked\"" ?> type="radio" name="ENVIALIA_HABILITAR_ENVIO_GRATUITO_INTERNACIONAL" value="0" />No
		  <input class="inputbox" <?php if(ENVIALIA_HABILITAR_ENVIO_GRATUITO_INTERNACIONAL=="1") echo "checked=\"checked\"" ?> type="radio" name="ENVIALIA_HABILITAR_ENVIO_GRATUITO_INTERNACIONAL" value="1" />Si
		</td>
		<td><?php echo mm_ToolTip("Habilita el envío gratuito INTERNACIONAL.") ?></td>
    </tr>
	<tr class="row0">
	  <td><strong>Servicio para envío gratuito INTERNACIONAL</strong></td>
	  <td>
	    <select class="inputbox" name="ENVIALIA_SERVICIO_ENVIO_GRATUITO_INTERNACIONAL">
              <option <?php if(!ENVIALIA_SERVICIO_ENVIO_GRATUITO_INTERNACIONAL) echo "selected=\"selected\"" ?> value="0"> - elija un servicio - </option>
	      <option <?php if(ENVIALIA_SERVICIO_ENVIO_GRATUITO_INTERNACIONAL=="EWW") echo "selected=\"selected\"" ?> value="EWW">E-COMM WORLDWIDE</option>
	      <option <?php if(ENVIALIA_SERVICIO_ENVIO_GRATUITO_INTERNACIONAL=="EEU") echo "selected=\"selected\"" ?> value="EEU">E-COMM EUROPE EXPRESS</option>
        </select>
	  </td>
	  <td><?php echo mm_ToolTip("Servicio para envío gratuito INTERNACIONAL") ?></td>
	</tr>
	<tr class="row0">
	  <td><strong>Importe mínimo envío gratuito INTERNACIONAL</strong></td>
	  <td>
            <input type="text" name="ENVIALIA_IMPORTE_MINIMO_ENVIO_GRATUITO_INTERNACIONAL" class="inputbox" value="<?php echo ENVIALIA_IMPORTE_MINIMO_ENVIO_GRATUITO_INTERNACIONAL ?>" />
	  </td>
	  <td><?php echo mm_ToolTip("Importe mínimo de pedido para envío gratuito INTERNACIONAL") ?></td>
	</tr>

        <tr>
            <td class="row0" colspan="3">
                <hr>
            </td>
        </tr>

	<tr class="row0">
	  <td><strong>HABILITAR SERVICIO E-COMM 24</strong></td>
	  <td>
		  <input class="inputbox" <?php if(ENVIALIA_ECOMM_24H=="0") echo "checked=\"checked\"" ?> type="radio" name="ENVIALIA_ECOMM_24H" value="0" />No
		  <input class="inputbox" <?php if(ENVIALIA_ECOMM_24H=="E24") echo "checked=\"checked\"" ?> type="radio" name="ENVIALIA_ECOMM_24H" value="E24" />Si
	  </td>
	  <td><?php echo mm_ToolTip("Habilita como método de envío este código de servicio. Este método solo está disponible para destinos ESPAÑA-PORTUGAL-ANDORRA") ?></td>
	</tr>
	<tr class="row1">
	  <td><strong>HABILITAR SERVICIO E-COMM 72</strong></td>
	  <td>
		  <input class="inputbox" <?php if(ENVIALIA_ECOMM_72H=="0") echo "checked=\"checked\"" ?> type="radio" name="ENVIALIA_ECOMM_72H" value="0" />No
		  <input class="inputbox" <?php if(ENVIALIA_ECOMM_72H=="E72") echo "checked=\"checked\"" ?> type="radio" name="ENVIALIA_ECOMM_72H" value="E72" />Si
	  </td>
	  <td><?php echo mm_ToolTip("Habilita como método de envío este código de servicio. Este método solo está disponible para destinos ESPAÑA-PORTUGAL-ANDORRA") ?></td>
	</tr>
	<tr class="row0">
	  <td><strong>HABILITAR SERVICIO E-COMM EUROPE EXPRESS</strong></td>
	  <td>
		  <input class="inputbox" <?php if(ENVIALIA_ECOMM_EUROPE_EXPRESS=="0") echo "checked=\"checked\"" ?> type="radio" name="ENVIALIA_ECOMM_EUROPE_EXPRESS" value="0" />No
		  <input class="inputbox" <?php if(ENVIALIA_ECOMM_EUROPE_EXPRESS=="EEU") echo "checked=\"checked\"" ?> type="radio" name="ENVIALIA_ECOMM_EUROPE_EXPRESS" value="EEU" />Si
	  </td>
	  <td><?php echo mm_ToolTip("Habilita como método de envío este código de servicio. Este servicio está disponible SOLO PARA LOS PAISES de destino DE-AT-BE-BG-CC-DK-SK-SI-EE-FI-FR-GR-GG-NL-HU-IE-IT-LV-LI-LT-LU-MC-NO-PL-GB-CZ-RO-SM-SE-CH-VA") ?></td>
	</tr>	
	<tr class="row1">
	  <td><strong>HABILITAR SERVICIO E-COMM WORLDWIDE</strong></td>
	  <td>
		  <input class="inputbox" <?php if(ENVIALIA_ECOMM_WORLDWIDE=="0") echo "checked=\"checked\"" ?> type="radio" name="ENVIALIA_ECOMM_WORLDWIDE" value="0" />No
		  <input class="inputbox" <?php if(ENVIALIA_ECOMM_WORLDWIDE=="EWW") echo "checked=\"checked\"" ?> type="radio" name="ENVIALIA_ECOMM_WORLDWIDE" value="EWW" />Si
	  </td>
	  <td><?php echo mm_ToolTip("Habilita como método de envío este código de servicio. Este método está disponible para TODOS LOS PAISES  de destino salvo ESPAÑA-PORTUGAL-ANDORRA") ?></td>
	</tr>

	<tr class="row0">
	  <td><strong>Impuesto</strong></td>
	  <td>
            <input type="text" name="ENVIALIA_IMPUESTO" class="inputbox" value="<?php echo ENVIALIA_IMPUESTO ?>" />
	  </td>
	  <td><?php echo mm_ToolTip("Impuesto agregado. Modo de uso, si quiere poner un 18% deberá escribir 0.18") ?></td>
	</tr>	
	
	<tr class="row1">
	  <td><strong>Coste fijo de envío</strong></td>
	  <td>
            <input type="text" name="ENVIALIA_COSTE_FIJO_ENVIO" class="inputbox" value="<?php echo ENVIALIA_COSTE_FIJO_ENVIO ?>" />
	  </td>
	  <td><?php echo mm_ToolTip("Precio fijo por envío") ?></td>
	</tr>	
	<tr class="row0">
	  <td><strong>Manipulación</strong></td>
		<td>
		<select class="inputbox" name="ENVIALIA_MANIPULACION">
		  <option <?php if(ENVIALIA_MANIPULACION=="F") echo "selected=\"selected\"" ?> value="F">Fijo</option>
		  <option <?php if(ENVIALIA_MANIPULACION=="V") echo "selected=\"selected\"" ?> value="V">Variable</option>
		</select>
		</td>
		<td><?php echo mm_ToolTip("Sistema de cálculo para el cargo de manipulación.") ?></td>
	</tr>
    <tr class="row1">
        <td><strong>Coste de manipulación</strong></td>
		<td>
            <input type="text" name="ENVIALIA_COSTE_MANIPULACION" class="inputbox" value="<?php echo ENVIALIA_COSTE_MANIPULACION ?>" />
		</td>
		<td><?php echo mm_ToolTip("Coste manipulación. (0 – sin coste)")  ?></td>
    </tr>
    <tr class="row0">
        <td><strong>Margen sobre coste de envío</strong></td>
		<td>
            <input type="text" name="ENVIALIA_MARGEN_COSTE_ENVIO" class="inputbox" value="<?php	echo ENVIALIA_MARGEN_COSTE_ENVIO ?>" />
		</td>
		<td><?php echo mm_ToolTip("Margen de incremento sobre tarifa de coste de envío") ?></td>
    </tr>
    <tr class="row1">
        <td><strong>Sobrescribir Código Postal Origen</strong></td>
		<td>
            <input type="text" name="ENVIALIA_SOBREESCRIBIR_CODIGO_POSTAL" class="inputbox" size="5" maxlength="5" value="<?php echo ENVIALIA_SOBREESCRIBIR_CODIGO_POSTAL ?>" />
		</td>
		<td><?php echo mm_ToolTip("Escriba el Código Postal para sobreescribir el existente.") ?></td>
    </tr>
    <tr class="row0">
      <td><strong>Ruta o path al archivo de tárifas</strong></td>
      <td>
      <p><?php echo CLASSPATH.'shipping/envialia.tarifas.csv'; ?></p>
      </td>
      <td><?php echo mm_ToolTip("Archivo de tarifas. Usted puede editar el archivo para personalizar las tarifas de los servicios de ENVIALIA. AVISO IMPORTANTE se deberá respetar el formato del archivo .csv, sin cambiar el nombre del mismo.") ?></td>
    </tr>

    </table>
   <?php	 	 
   // return false if there's no configuration
   return true;
	}
	/**
  * Returns the "is_writeable" status of the configuration file
  * @param void
  * @returns boolean True when the configuration file is writeable, false when not
  */
	function configfile_writeable() {
		return is_writeable( CLASSPATH."shipping/".__CLASS__.".cfg.php" );
	}

	function save_rate_info(&$d) {

		$shipping_rate_id = $d['shipping_rate_id'];
		$is_arr = explode("|", urldecode(urldecode($shipping_rate_id)));

		$shipping_info = explode(";", $is_arr[5]);
		$ship_date = $shipping_info[0];
		$service_code = $shipping_info[1];
		$special_service = $shipping_info[2];
		$package_type = $shipping_info[3];
		if ($shipping_info[4] == 'I')
			$is_international = true;
		else
			$is_international = false;
		$addl_prot = $shipping_info[5];
		$order_weight = $shipping_info[6];
		$duty_value = $shipping_info[7];
		$insurance = $shipping_info[8];
		$content_desc = $shipping_info[9];

		$q = "INSERT INTO #__{vm}_shipping_label ";
		$q .= "(order_id, shipper_class, ship_date, service_code, ";
		$q .= "special_service, package_type, order_weight, ";
		$q .= "is_international, additional_protection_type, ";
		$q .= "additional_protection_value, duty_value, content_desc, ";
		$q .= "label_is_generated) ";
		$q .= "VALUES (";
		$q .= "'" . $d['order_id'] . "', ";
		$q .= "'" . __CLASS__ . "', ";
		$q .= "'" . $ship_date . "', ";
		$q .= "'" . $service_code . "', ";
		$q .= "'" . $special_service . "', ";
		$q .= "'" . $package_type . "', ";
		$q .= "'" . $order_weight . "', ";
		$q .= "'" . $is_international . "', ";
		$q .= "'" . $addl_prot . "', ";
		$q .= "'" . $insurance . "', ";
		$q .= "'" . $duty_value . "', ";
		$q .= "'" . $content_desc . "', ";
		$q .= "'0'";
		$q .= ")";

		$db = new ps_DB;
		$db->query($q);
		$db->next_record();
	}

	/**
	* Writes the configuration file for this shipping method
	* @param array An array of objects
	* @returns boolean True when writing was successful
	*/
	function write_configuration( &$d ) {
		global $vmLogger;

		$my_config_array = array(
                    "ENVIALIA_URL"              => vmGet( $d, 'ENVIALIA_URL' ),
                    "ENVIALIA_CODIGO_AGENCIA"   => vmGet( $d, 'ENVIALIA_CODIGO_AGENCIA' ),
                    "ENVIALIA_CODIGO_CLIENTE"   => vmGet( $d, 'ENVIALIA_CODIGO_CLIENTE' ),
                    "ENVIALIA_PASSWORD_CLIENTE" => vmGet( $d, 'ENVIALIA_PASSWORD_CLIENTE' ),
                    "ENVIALIA_ECOMM_24H" => vmGet( $d, 'ENVIALIA_ECOMM_24H' ),
                    "ENVIALIA_ECOMM_72H" => vmGet( $d, 'ENVIALIA_ECOMM_72H' ),
                    "ENVIALIA_ECOMM_WORLDWIDE" => vmGet( $d, 'ENVIALIA_ECOMM_WORLDWIDE' ),
                    "ENVIALIA_ECOMM_EUROPE_EXPRESS" => vmGet( $d, 'ENVIALIA_ECOMM_EUROPE_EXPRESS' ),
                    "ENVIALIA_COSTE_FIJO_ENVIO" => vmGet( $d, 'ENVIALIA_COSTE_FIJO_ENVIO' ),
                    "ENVIALIA_MANIPULACION" => vmGet( $d, 'ENVIALIA_MANIPULACION' ),
                    "ENVIALIA_COSTE_MANIPULACION" => vmGet( $d, 'ENVIALIA_COSTE_MANIPULACION' ),
                    "ENVIALIA_MARGEN_COSTE_ENVIO" => vmGet( $d, 'ENVIALIA_MARGEN_COSTE_ENVIO' ),
                    "ENVIALIA_SOBREESCRIBIR_CODIGO_POSTAL" => vmGet( $d, 'ENVIALIA_SOBREESCRIBIR_CODIGO_POSTAL' ),
                    
                    "ENVIALIA_HABILITAR_ENVIO_GRATUITO" => vmGet( $d, 'ENVIALIA_HABILITAR_ENVIO_GRATUITO' ),
                    "ENVIALIA_SERVICIO_ENVIO_GRATUITO" => vmGet( $d, 'ENVIALIA_SERVICIO_ENVIO_GRATUITO' ),
                    "ENVIALIA_IMPORTE_MINIMO_ENVIO_GRATUITO" => vmGet( $d, 'ENVIALIA_IMPORTE_MINIMO_ENVIO_GRATUITO' ),
                    
                    "ENVIALIA_HABILITAR_ENVIO_GRATUITO_INTERNACIONAL" => vmGet( $d, 'ENVIALIA_HABILITAR_ENVIO_GRATUITO_INTERNACIONAL' ),
                    "ENVIALIA_SERVICIO_ENVIO_GRATUITO_INTERNACIONAL" => vmGet( $d, 'ENVIALIA_SERVICIO_ENVIO_GRATUITO_INTERNACIONAL' ),
                    "ENVIALIA_IMPORTE_MINIMO_ENVIO_GRATUITO_INTERNACIONAL" => vmGet( $d, 'ENVIALIA_IMPORTE_MINIMO_ENVIO_GRATUITO_INTERNACIONAL' ),
                    "ENVIALIA_IMPUESTO" => vmGet( $d, 'ENVIALIA_IMPUESTO' )
        );
		$config = "<?php	 	 	                                                                                                                                	 \n";
		$config .= "if( !defined( '_VALID_MOS' ) && !defined( '_JEXEC' ) ) die( 'Direct Access to '.basename(__FILE__).' is not allowed.' ); \n\n";
		foreach( $my_config_array as $key => $value ) {
			$value = str_replace("'", "\'", $value );
			$config .= "define ('$key', '$value');\n";
		}

		$config .= "?>";

		if ($fp = fopen(CLASSPATH ."shipping/".__CLASS__.".cfg.php", "w")) {
			fputs($fp, $config, strlen($config));
			fclose ($fp);
			$vmLogger->info( 'The configuration has been updated.' );
			return true;
		}
		else {
			$vmLogger->err( "Error writing to configuration file" );
			return false;
		}
	}

    function agregar_impuesto($pais){
			
            $paises = Array("AT","BE","BG","CC","CY","CZ","DK","EE","FI",
                            "FR","DE","GR","HU","IE","IT","LV","LT","LU",
                            "MT","NL","PL","PT","RO","SK","SI","ES","SE","GB");
            $max=count($paises);
            for($i=0;$i<$max;$i++){
                if($pais == $paises[$i]){
                    return true;
                }
            }
            return false;
	}
	
	protected function tarifas(){
	    $archivo = CLASSPATH.'shipping/envialia.tarifas.csv';
	    $tarifas = Array();
	    
	    $fp = fopen ( $archivo , "r" );
            while (( $data = fgetcsv ( $fp , 1000 , ";" )) !== FALSE ) { // Mientras hay líneas que leer...
                $tarifas[] = Array( "servicio"      => $data[0],
                                    "pais"          => $data[1],
                                    "cp_origen"     => $data[2],
                                    "cp_destino"    => $data[3],
                                    "peso"          => $data[4],
                                    "importe"       => $data[5]);
            }
            fclose ( $fp );
            return $tarifas;
	}

        function dame_tarifa($tarifas,$servicio,$pais,$cp,$peso){
            $max=count($tarifas);
            $cp=intval($cp);
            $peso=ceil($peso); //redondeo para arriba
            $segmento = Array();

            for($i=1;$i<$max;$i++){
                // Si es un envio para ES-PT-AD
                if($servicio == 'E24' || $servicio == 'E72'){
                    if($tarifas[$i]['servicio'] == $servicio){
                        if($tarifas[$i]['pais'] == $pais){
                            $cp_origen=intval($tarifas[$i]['cp_origen']);
                            $cp_destino=intval($tarifas[$i]['cp_destino']);
                            if($cp >= $cp_origen){
                                if($cp <= $cp_destino){
                                    $segmento[]=Array("peso" => floatval($tarifas[$i]['peso']),"precio" => floatval($tarifas[$i]['importe']));
                                }
                            }
                        }
                    }
                }
                //Servico Europeo o Internacional
                else{
                    if($tarifas[$i]['servicio'] == $servicio){
                        if($tarifas[$i]['pais'] == $pais){
                            $segmento[]=Array("peso" => floatval($tarifas[$i]['peso']),"precio" => floatval($tarifas[$i]['importe']));
                        }
                    }
                }
            }
            // ya tenemos el segmento

            // Metodo para ordenar arrays con arrays asociativos dentro
            if(!function_exists('ordenar')){
                function ordenar($x, $y){
                    if ( $x['peso'] == $y['peso'] ){
                        return 0;
                    }
                    //ordenar de menor a mayor
                    else if ( $x['peso'] < $y['peso'] ){
                        return -1;
                    }
                    else{
                        return 1;
                    }
                }
            }

            // Ordenamos el segmento
            usort($segmento,'ordenar');
            // Preparamos los datos para el peso minimo y maximo
            $precio_envio = 0;
            $max=count($segmento);
            $peso_min = floatval($segmento[0]['peso']);
            $precio_min = floatval($segmento[0]['precio']);
            $peso_max = floatval($segmento[$max-2]['peso']);
            $precio_max = floatval($segmento[$max-2]['precio']);
            $precio_despues_max = floatval($segmento[$max-1]['precio']);

            if($peso <= $peso_min){
                $precio_envio = $precio_min;
            }
            else if($peso >= $peso_max){
                $peso_restante = $peso-$peso_max;
                $precio_restante = $peso_restante*$precio_despues_max;
                $precio_envio = $precio_max+$precio_restante;
            }
            else{
                for($i=0;$i<$max;$i++){
                    if($peso != $segmento[$i]['peso']){
                        if($peso < $segmento[$i]['peso']){
                            $precio_envio = $segmento[$i]['precio'];
                            $i=$max;
                        }
                    }
                    else{ //es igual
                        $precio_envio = $segmento[$i]['precio'];
                        $i=$max;
                    }
                }
            }
            return $precio_envio;
        }

        function es_europeo($pais){
            $paises = Array("DE","AT","BE","BG","CC","DK","SK","SI","EE","FI","FR","GR","GG",
                            "NL","HU","IE","IT","LV","LI","LT","LU","MC","NO","PL","GB","CZ",
                            "RO","SM","SE","CH","VA");
            $max=count($paises);
            for($i=0;$i<$max;$i++){
                if($pais == $paises[$i]){
                    return true;
                }
            }
            return false;
        }

        function crear_string_shipping_rate_id($tipo_servicio,$importe,$valor,$peso){
            global $total;
            $id_string = __CLASS__;
            $id_string .= "|ENVIALIA";
            $id_string .= "|" . $tipo_servicio;
            $id_string .= "|" . $importe;
            $id_string .= "|";
            $id_string .= "|"; #$ship_date;
            $id_string .= ";" . $tipo_servicio;
            $id_string .= ";" . $valor; #"$method['special_service'];????
            $id_string .= ";"; #$method['package_type'];
            // es internacional
            if($tipo_servicio == 'EWW'){
                $id_string .= ";I";  #internacional
            }
            else{
                $id_string .= ";";  #internacional
            }
            $id_string .= ";"; #$addl_prot
            $id_string .= ";" . $peso;
            $id_string .= ";" . $total; # $duty_value;
            $id_string .= ";"; #seguro
            $id_string .= ";"; #content_desc
            return(urlencode($id_string));
        }
    // Generamos la etiqueta para imprimir
    // Realizamos el pedido
    function generate_label($order_id)
    {
        global $vmLogger;
        global $VM_LANG, $mosConfig_absolute_path;

        /** Read current Configuration ***/
        require_once(CLASSPATH ."shipping/".__CLASS__.".cfg.php");
        require_once( CLASSPATH.'nusoap/nusoap.php' );

        // Primero de todo nos logueamos si esto falla todo lo demas no tiene sentido
        $envialiaURL = ENVIALIA_URL."/soap?service=LoginWSService";
        $clienteSoap = new nusoap_client($envialiaURL);
        if ($sError = $clienteSoap->getError()) {
                $vmLogger->err($sError);
                return;
        }
        $parametros=array("strCodAge"   => ENVIALIA_CODIGO_AGENCIA,
                          "strCod"      => ENVIALIA_CODIGO_CLIENTE,
                          "strPass"     => ENVIALIA_PASSWORD_CLIENTE);
        $respuesta=$clienteSoap->call("LoginCli",$parametros);
        // Existe alguna falla en el servicio?
        if ($clienteSoap->fault) { // Si
            $vmLogger->err( $respuesta['faultcode']."".$respuesta['faultstring']);
            return;
        } else { // No
            $sError = $clienteSoap->getError();
            if ($sError) {
                $vmLogger->err($sError);
                return;
            }
            $id_sesion_cliente=$respuesta['strSesion'];
        }
        unset($clienteSoap);

        // Ya tenemos el id_sesion
        // Vamos a por todos los datos necesarios para realizar el pedido

        $dbl = new ps_DB;
        $q = "SELECT order_id, ship_date, service_code, special_service, ";
        $q .= "package_type, order_weight, is_international, ";
        $q .= "additional_protection_type, additional_protection_value, ";
        $q .= "duty_value, content_desc, label_is_generated ";
        $q .= "FROM #__{vm}_shipping_label ";
        $q .= "WHERE order_id = '" . $order_id . "'";
        $dbl->query($q);
        if (!$dbl->next_record()) {
                $vmLogger->err("couldn't find label info for order #" . $order_id);
                return (false);
        }

        if ($dbl->f('order_weight') == 0)
                return (false);

        if ($dbl->f('label_is_generated'))
                return (true);

        $envialia_tipo_servicio = $dbl->f('service_code');        
        $envialia_peso_origen = $dbl->f('order_weight');
        $envialia_referencia = $order_id;
        $envialia_numero_paquetes = 1;

        //obtenemos el importe total
        $query = "SELECT order_total FROM #__{vm}_orders WHERE order_id = '".$order_id."'";
        $dbl->query($query);
        $dbl->next_record();
        $envialia_importe_servicio = $dbl->f('order_total');

        // Datos del comprador
        $db = new ps_DB;
        $q = "SELECT first_name,last_name,address_1,address_2,";
        $q .= "city,state,country,zip,phone_1,user_email,country_2_code ";
        $q .= "FROM #__{vm}_order_user_info, #__{vm}_country ";
        $q .= "WHERE order_id = '" . $order_id . "' ";
        $q .= "AND (country=country_2_code OR country=country_3_code)";
        $q .= "AND address_type='ST'";
        $db->query($q);
        if (!$db->next_record()) {
            /* If we can't find a ship-to address use bill-to */
            $q = "SELECT first_name,last_name,address_1,address_2,";
            $q .= "city,state,country,zip,phone_1,user_email,country_2_code ";
            $q .= "FROM #__{vm}_order_user_info, #__{vm}_country ";
            $q .= "WHERE order_id = '" . $order_id . "' ";
            $q .= "AND (country=country_2_code OR country=country_3_code)";
            $q .= "AND address_type='BT'";
            $db->query($q);
            if (!$db->next_record()) {
                $vmLogger->err("user info for order #" . $order_id . " not found");
                return (false);
            }
        }
        //rellenamos campos del comprador
        $envialia_nombre_destinatario       = $db->f('first_name'). ' ' . $db->f('last_name');
        $envialia_nombre_via_destinatario   = $db->f('address_1');
        $envialia_poblacion_destinatario    = $db->f('city');
        $envialia_CP_destinatario           = $db->f('zip');
        $envialia_cod_provincia_destinatario= $db->f('state');
        $envialia_telefono_destinatario     = $db->f('phone_1');
        $envialia_email_destinatario        = $db->f('user_email');
        $envialia_pais = $db->f('country_2_code');

        //HAY QUE CONTROLAR SI EL COMPRADOR A ELEGIDO CONTRAREEMBOLSO Y PONERLO EN EL PARAMETRO
        $query = "SELECT payment_method_id FROM #__{vm}_order_payment where order_id='".$order_id."'";
        $db->query($query);
        $db->next_record();
        if($db->f('payment_method_id') == '2'){
            $envialia_reembolso=floatval($envialia_importe_servicio);
        }
        else{
            $envialia_reembolso = 0;
        }

        //controlar de que pais es el comprador
        if($envialia_pais == 'ES' || $envialia_pais == 'PT' || $envialia_pais == 'AD'){
            $envialia_pais = '';
        }

        // Datos del vendedor
        $vq  = "SELECT * FROM #__{vm}_vendor ";
        $vq .= "WHERE vendor_id='" . $_SESSION['ps_vendor_id'] . "'";
        $db->query($vq);
        $db->next_record();

        $envialia_nombre_remitente          = $db->f('vendor_name');
        $envialia_nombre_via_remitente      = $db->f('vendor_address_1');
        $envialia_poblacion_remitente       = $db->f('vendor_city');
        $envialia_cod_provincia_remitente   = $db->f('vendor_state');
        $envialia_telefono_remitente        = $db->f('contact_phone_1');
        // comprobar si tenemos que sobreescribir el CP
        if(ENVIALIA_SOBREESCRIBIR_CODIGO_POSTAL){
            $envialia_CP_remitente = ENVIALIA_SOBREESCRIBIR_CODIGO_POSTAL;
        }
        else{
            $envialia_CP_remitente = $db->f('vendor_zip');            
        }


        //Realizamos el pedido
        $envialiaURL = ENVIALIA_URL."/soap?service=WebServService";
        $tipo_envio = Array();

        $clienteSoap = new nusoap_client($envialiaURL);
        if ($sError = $clienteSoap->getError()) {
            $vmLogger->err($sError);
            return false;
        }

        $headers='<ROClientIDHeader xmlns="http://tempuri.org/"><ID>'.$id_sesion_cliente.'</ID></ROClientIDHeader>';
        $parametros=array("strCodAgeCargo"      => ENVIALIA_CODIGO_AGENCIA,
                          "strCodAgeOri"        => ENVIALIA_CODIGO_AGENCIA,
                          "dtFecha"             => date("Y/m/d"),
                          "strCodTipoServ"      => $envialia_tipo_servicio,
                          "strCodCli"           => ENVIALIA_CODIGO_CLIENTE,

                          "strNomOri"           => $envialia_nombre_remitente,
                          "strDirOri"           => $envialia_nombre_via_remitente,
                          "strPobOri"           => $envialia_poblacion_remitente,
                          "strCPOri"            => $envialia_CP_remitente,
                          "strCodProOri"        => $envialia_cod_provincia_remitente,
                          "strTlfOri"           => $envialia_telefono_remitente,

                          "strNomDes"           => $envialia_nombre_destinatario,
                          "strDirDes"           => $envialia_nombre_via_destinatario,
                          "strPobDes"           => $envialia_poblacion_destinatario,
                          "strCPDes"            => $envialia_CP_destinatario,
                          "strCodProDes"        => $envialia_cod_provincia_destinatario,
                          "strTlfDes"           => $envialia_telefono_destinatario,
                          "strDesDirEmails"	=> $envialia_email_destinatario,

                          "intPaq"              => $envialia_numero_paquetes,
                          "dPesoOri"            => floatval($envialia_peso_origen),
                          "dReembolso"          => $envialia_reembolso,
                          "strCodPais"          => $envialia_pais,
                          "strRef"              => $envialia_referencia,
                          "boInsert"=> true);

        $clienteSoap->setHeaders($headers);
        $respuesta=$clienteSoap->call("GrabaEnvio4",$parametros);
        // Existe alguna falla en el servicio?
        if ($clienteSoap->fault) { // Si
            $vmLogger->err( "Envialia error (GrabaEnvio4) :".$respuesta['faultcode']."".$respuesta['faultstring']);
            echo $envialia_tipo_servicio."<br/>";
            return;
        } else { // No
            $sError = $clienteSoap->getError();
            if ($sError) {
                $vmLogger->err($sError);
                echo $envialia_tipo_servicio."<br/>";
                return;
            }
            $envialia_num_albaran = $respuesta['strAlbaranOut'];
            $envialia_num_seguimiento = $respuesta['strGuidOut'];
        }
        unset($clienteSoap);

        //Ahora ya tenemos para obtener el codigo de barras
        $envialiaURL = ENVIALIA_URL."/soap?service=WebServService";
        $tipo_envio = Array();

        $clienteSoap = new nusoap_client($envialiaURL);
        if ($sError = $clienteSoap->getError()) {
            $vmLogger->err($sError);
            return;
        }

        $headers='<ROClientIDHeader xmlns="http://tempuri.org/"><ID>'.$id_sesion_cliente.'</ID></ROClientIDHeader>';
        $parametros=array("strAlbaran" => $envialia_num_albaran);

        $clienteSoap->setHeaders($headers);
        $respuesta=$clienteSoap->call("ConsEtiquetaEnvio",$parametros);
        // Existe alguna falla en el servicio?
        if ($clienteSoap->fault) { // Si
            $vmLogger->err( $respuesta['faultcode']."".$respuesta['faultstring']);
            return;
        } else { // No
            $sError = $clienteSoap->getError();
            if ($sError) {
                $vmLogger->err($sError);
                return;
            }
            $envialia_etiqueta_envio = $respuesta;
        }
        unset($clienteSoap);

        // insert label image into database and mark that the label has
        //been generated.

        //Antes tenemos que parsear el numero de seguimiento porque no entra en la tabla max 32 chars
        $envialia_num_seguimiento=$this->comprimir_num_track($envialia_num_seguimiento);
        
        $q = "UPDATE #__{vm}_shipping_label ";
        $q .= "SET ";
        $q .= "ship_date='".date("d/m/y")."', ";
        $q .= "label_is_generated='1', ";
        $q .= "tracking_number='" . $envialia_num_seguimiento . "', ";
        $q .= "label_image='" . $envialia_etiqueta_envio . "' ";
        $q .= "WHERE order_id = '" . $order_id . "'";

        $dbnl = new ps_DB;
        $dbnl->query($q);
        $dbnl->next_record();

        return (true);
    }

    function get_label_dimensions($order_id) {
            global $vmLogger;

            /* Retrieve label information from database */
            $dbl = new ps_DB;
            $q = "SELECT is_international ";
            $q .= "FROM #__{vm}_shipping_label ";
            $q .= "WHERE order_id = '" . $order_id . "'";
            $dbl->query($q);
            if (!$dbl->next_record()) {
                    $vmLogger->err("couldn't find label info for order #" .$order_id);
                    return;
            }

            if ($dbl->f('is_international'))
                    $dim = '669x559';
            else
                    $dim = '669x724';
            return ($dim);
    }

    function get_label_image_type($order_id) {

        $pdf = $this->get_label_image($order_id);
        
        header("Content-type: application/pdf");
        header('Content-Disposition: attachment; filename="etiqueta_'.$order_id.'.pdf"'); //solo para forzar descarga

        echo $pdf;
        exit();
        return ('application/pdf');
        //return ;
    }

    function get_label_image($order_id) {
            global $vmLogger;

            /* Retrieve label information from database */
            $dbl = new ps_DB;
            $q = "SELECT label_is_generated, label_image ";
            $q .= "FROM #__{vm}_shipping_label ";
            $q .= "WHERE order_id = '" . $order_id . "'";
            $dbl->query($q);
            if (!$dbl->next_record()) {
                    $vmLogger->err("couldn't find label info for order #" .
                        $order_id);
                    return;
            }

            if (!$dbl->f('label_is_generated')) {
                    $vmLogger->err("label has not been generated");
                    return;
            }

            $label_image = base64_decode($dbl->f('label_image'));
            return ($label_image);
    }
    function comprimir_num_track($codigo){
        $codigo = substr($codigo,1,36);
        $separar = split("-",$codigo);
        $comprimir="";
        foreach($separar as $linea){
            $comprimir.=$linea;
        }
        return $comprimir;
    }

    function descomprimir_num_track($codigo){
        $desc="";
        $desc = substr($codigo,0,8);
        $desc .="-";
        $desc .= substr($codigo,8,4);
        $desc .="-";
        $desc .= substr($codigo,12,4);
        $desc .="-";
        $desc .= substr($codigo,16,4);
        $desc .="-";
        $desc .= substr($codigo,20,12);
        return $desc;
    }
    function track($order_id) {
        global $vmLogger, $sess;
        global $VM_LANG, $mosConfig_absolute_path;

      
        $dbl = new ps_DB;
        $q = "SELECT ship_date, tracking_number, label_is_generated, is_international ";
        $q .= "FROM #__{vm}_shipping_label ";
        $q .= "WHERE order_id = '" . $order_id . "'";
        $dbl->query($q);
        if (!$dbl->next_record() || !$dbl->f("label_is_generated") || !$dbl->f("ship_date"))
                return ("couldn't find label info for order #" .  $order_id);

        $envialia_num_tracking = $dbl->f('tracking_number');
        $envialia_fecha = $dbl->f('ship_date');

        require_once(CLASSPATH . "shipping/" . __CLASS__ .".cfg.php");
        require_once( CLASSPATH.'nusoap/nusoap.php' );

        // Primero de todo nos logueamos si esto falla todo lo demas no tiene sentido
        $envialiaURL = ENVIALIA_URL."/soap?service=LoginWSService";
        $clienteSoap = new nusoap_client($envialiaURL);
        if ($sError = $clienteSoap->getError()) {
                $vmLogger->err($sError);
                return;
        }
        $parametros=array("strCodAge"   => ENVIALIA_CODIGO_AGENCIA,
                          "strCod"      => ENVIALIA_CODIGO_CLIENTE,
                          "strPass"     => ENVIALIA_PASSWORD_CLIENTE);
        $respuesta=$clienteSoap->call("LoginCli",$parametros);
        // Existe alguna falla en el servicio?
        if ($clienteSoap->fault) { // Si
            $vmLogger->err( $respuesta['faultcode']."".$respuesta['faultstring']);
            return;
        } else { // No
            $sError = $clienteSoap->getError();
            if ($sError) {
                $vmLogger->err($sError);
                return;
            }
            $envialia_url_seguimiento=$respuesta['strURLDetSegEnv'];
        }
        unset($clienteSoap);
        
        //ya tenemos los datos para la url de seguimiento la montamos
        $envialia_num_tracking=$this->descomprimir_num_track($envialia_num_tracking);
        $cortar=split("\?",$envialia_url_seguimiento);
        $envialia_url_seguimiento=$cortar[0];

        $enlace=$envialia_url_seguimiento."?servicio=".$envialia_num_tracking."&fecha=".$envialia_fecha;

        Header("Location: $enlace");
        exit();
    }
    function void_label($order_id) {return ('');}
}
?>

